--新英雄主题活动 战斗布阵Window
checkRequire("Lua_FightLineupWindow");
Lua_NewHeroActStoryLineupWindow = class("Lua_NewHeroActStoryLineupWindow", Lua_FightLineupWindow);
function Lua_NewHeroActStoryLineupWindow:ctor()
    self:superCall("ctor");

    self.windowName = "Lua_NewHeroActStoryLineupWindow";
end

function Lua_NewHeroActStoryLineupWindow:buildShowItem()
    self:superCall("buildShowItem");

    self.heroList:setListCell(Lua_NewHeroActStoryLineupItem, 107, 107, 5);
end

function Lua_NewHeroActStoryLineupWindow:dispose()
    self:superCall("dispose");
end

function Lua_NewHeroActStoryLineupWindow:updateShowInfo(param)
    self.template_id = param.template_id;
    self.stage_id = param.stage_id;

    if DataCenter.newHeroActData.heroLineup ~= nil then
        local info = { lineup_type = Lua_HeroUtil.LINEUP_STORY, detachment_list = DataCenter.newHeroActData.heroLineup };
        DataCenter.heroLineupData:addLineupInfo(info);
    end

    self.lineup_type = Lua_HeroUtil.LINEUP_STORY;
    self:showSceneByTemplateId(self.template_id);
    self:updateLineupInfo();
    self.campSiftPanel:setSelected(self.default_camp, 0);
end

function Lua_NewHeroActStoryLineupWindow:updateHeroList()
    local arr = DataCenter.newHeroActData.heroVoArr;
    self.heroList.customParam = self.lineup_type * 10000 + self.lineupIdx * 100
    self.heroList:setArrayData(arr); -- 剧情布阵可选英雄列表
    self:showNone(arr == nil or arr:getSize() <= 0);
end

-- 更新模型展示
function Lua_NewHeroActStoryLineupWindow:updateSceneModel()
    if self.localLineupDic == nil or self.lineupIdx == nil then
        return;
    end

    local tab = {};
    local arr = self.localLineupDic[self.lineupIdx];
    local heroVo;
    for i = 1, arr:getSize() do
        if arr[i] > 0 then
            heroVo = DataCenter.newHeroActData.heroUidList[arr[i]];
            tab[i] = heroVo;
        end
    end

    self:showSceneModel(tab);
end

-- 己方光环更新
function Lua_NewHeroActStoryLineupWindow:updateAureoleInfo()
    local standArr = self.localLineupDic[self.lineupIdx];
    local force = self:calcLineupForce(standArr);
    local aureole_list = self:getAureoleInfo(standArr);
    local aureole_id = DataCenter.heroLineupUtil:getAureoleId(aureole_list);
    self.leftAureoleItem:setData(aureole_id, DataCenter.roleData.name, force);
end

-- 布阵战力
function Lua_NewHeroActStoryLineupWindow:calcLineupForce(arr)
    local force = 0;
    local heroVo;
    for i = 1, arr:getSize() do
        if arr[i] > 0 then
            heroVo = DataCenter.newHeroActData.heroUidList[arr[i]];
            force = force + heroVo.heroForce;
        end
    end
    return force;
end

-- 站位
function Lua_NewHeroActStoryLineupWindow:getAureoleInfo(arr)
    local tab = {};
    local heroVo;
    for i = 1, arr:getSize() do
        if arr[i] > 0 then
            heroVo = DataCenter.newHeroActData.heroUidList[arr[i]];
            if tab[heroVo.campType] == nil then
                tab[heroVo.campType] = 1;
            else
                tab[heroVo.campType] = tab[heroVo.campType] + 1;
            end
        end
    end
    return tab;
end

function Lua_NewHeroActStoryLineupWindow:onStartFight()
    if self:checkIsChange() then
        -- 设置新的阵容
        Lua_MsgUtil.callFunc("SET_NEWHEROSTORY_LINEUP_INFO", {stage_id = self.stage_id, stand_type = self.data.localStandTypeDic, hero_lineup = self.localLineupDic, artifact_list = self.localArtifactDic});
    end

    Lua_ProxyManager.getProxy("Lua_FightProxy"):sStartFight(self.template_id, self.stage_id);
end





--------------------------------------------------





Lua_NewHeroActStoryLineupItem = class("Lua_NewHeroActStoryLineupItem", Lua_HeroLineupCell);
function Lua_NewHeroActStoryLineupItem:buildShowItem()
    self:superCall("buildShowItem");
end

function Lua_NewHeroActStoryLineupItem:setData(data)
    self.data = data;
    if data == nil then
        return;
    end
    
    self.itemIcon:setData(data);
    self:updateSelected();
end

function Lua_NewHeroActStoryLineupItem:onPressClick()
    if DataCenter.newHeroActData:checkLeadHero(self.data.unique_id)then
        OperateAlert.show("主角不能下阵");
        return false;
    else
        Lua_MsgUtil.callFunc("LINEUP_HERO_SELECT", self.data);
        return true;
    end
end

function Lua_NewHeroActStoryLineupItem:dispose()
    self:superCall("dispose");
end